scala.reflect.api.Trees

# SuperApi

###
Related Doc: package Trees

#### trait SuperApi extends Universe.TermTreeApi

The API that all supers support

Self Type
  Universe.Super
Source
  Trees.scala

Linear Supertypes
Universe.TermTreeApi, Universe.TreeApi, Product, Equals, AnyRef, Any
Known Subclasses
Super
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. SuperApi
2. TermTreeApi
3. TreeApi
4. Product
5. Equals
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def canEqual(that: Any): Boolean

   Definition Classes
     Equals

2. #### abstract def canHaveAttrs: Boolean

   Can this tree carry attributes (i.e.

   Can this tree carry attributes (i.e. symbols, types or positions)? Typically the answer is yes, except for the `EmptyTree` null object and two special singletons: `noSelfType` and `pendingSuperCall`.

   Definition Classes
     TreeApi

3. #### abstract def children: List[Universe.Tree]

   The direct child trees of this tree.

   The direct child trees of this tree. EmptyTrees are always omitted. Lists are flattened.

   Definition Classes
     TreeApi

4. #### abstract def collect[T](pf: PartialFunction[Universe.Tree, T]): List[T]

   Apply `pf` to each subtree on which the function is defined and collect the results.

   Apply `pf` to each subtree on which the function is defined and collect the results.

   Definition Classes
     TreeApi

5. #### abstract def duplicate: SuperApi.this.type

   Make a copy of this tree, keeping all attributes, except that all positions are focused (so nothing in this tree will be found when searching by position).

   Make a copy of this tree, keeping all attributes, except that all positions are focused (so nothing in this tree will be found when searching by position).

   Definition Classes
     TreeApi

6. #### abstract def equalsStructure(that: Universe.Tree): Boolean

   Tests whether two trees are structurally equal.

   Tests whether two trees are structurally equal. Note that `==` on trees is reference equality.

   Definition Classes
     TreeApi

7. #### abstract def exists(p: (Universe.Tree) ⇒ Boolean): Boolean

   Is there exists a part of this tree which satisfies predicate `p`?

   Is there exists a part of this tree which satisfies predicate `p`?

   Definition Classes
     TreeApi

8. #### abstract def filter(f: (Universe.Tree) ⇒ Boolean): List[Universe.Tree]

   Find all subtrees matching predicate `p`.

   Find all subtrees matching predicate `p`. Same as `withFilter`

   Definition Classes
     TreeApi

9. #### abstract def find(p: (Universe.Tree) ⇒ Boolean): Option[Universe.Tree]

   Returns optionally first tree (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

   Returns optionally first tree (in a preorder traversal) which satisfies predicate `p`, or None if none exists.

   Definition Classes
     TreeApi

10. #### abstract def forAll(p: (Universe.Tree) ⇒ Boolean): Boolean

    Do all parts of this tree satisfy predicate `p`?

    Do all parts of this tree satisfy predicate `p`?

    Definition Classes
      TreeApi

11. #### abstract def foreach(f: (Universe.Tree) ⇒ Unit): Unit

    Apply `f` to each subtree

    Apply `f` to each subtree

    Definition Classes
      TreeApi

12. #### abstract def isDef: Boolean

    Does this tree represent a definition? (of a method, of a class, etc)

    Does this tree represent a definition? (of a method, of a class, etc)

    Definition Classes
      TreeApi

13. #### abstract def isEmpty: Boolean

    Is this tree one of the empty trees?

    Is this tree one of the empty trees?

    Empty trees are: the `EmptyTree` null object and `TypeTree` instances that don't carry a type.

    Definition Classes
      TreeApi
    See also

      `canHaveAttrs`

14. #### abstract def isTerm: Boolean

    The canonical way to test if a Tree represents a term.

    The canonical way to test if a Tree represents a term.

    Definition Classes
      TreeApi

15. #### abstract def isType: Boolean

    The canonical way to test if a Tree represents a type.

    The canonical way to test if a Tree represents a type.

    Definition Classes
      TreeApi

16. #### abstract def mix: Universe.TypeName

    The selector of the `super` expression.

    The selector of the `super` expression. See the example for scala.reflect.api.Trees#SuperExtractor.

17. #### abstract def nonEmpty: Boolean

    Is this tree not an empty tree?

    Is this tree not an empty tree?

    Definition Classes
      TreeApi
    See also

      `isEmpty`

18. #### abstract def orElse(alt: ⇒ Universe.Tree): Universe.Tree

    Provides an alternate if tree is empty

    Provides an alternate if tree is empty

    alt

      The alternate tree

    returns

      If this tree is non empty, this tree, otherwise `alt`.

    Definition Classes
      TreeApi

19. #### abstract def pos: Universe.Position

    Position of the tree.

    Position of the tree.

    Definition Classes
      TreeApi

20. #### abstract def productArity: Int

    Definition Classes
      Product

21. #### abstract def productElement(n: Int): Any

    Definition Classes
      Product

22. #### abstract def qual: Universe.Tree

    The qualifier of the `super` expression.

    The qualifier of the `super` expression. See the example for scala.reflect.api.Trees#SuperExtractor.

23. #### abstract def symbol: Universe.Symbol

    Symbol of the tree.

    Symbol of the tree.

    For most trees symbol is `null`. In `SymTree`s, it is overridden and implemented with a var, initialized to `NoSymbol`.

    Trees which are not `SymTree`s but which carry symbols do so by overriding `def symbol` to forward it elsewhere. Examples:

    - `Super(qual, _)` has `qual`'s symbol,
    - `Apply(fun, args)` has `fun`'s symbol,
    - `TypeApply(fun, args)` has `fun`'s symbol,
    - `AppliedTypeTree(tpt, args)` has `tpt`'s symbol,
    - `TypeTree(tpe)` has `tpe`'s `typeSymbol`, if `tpe != null`.
    Definition Classes
      TreeApi

24. #### abstract def tpe: Universe.Type

    Type of the tree.

    Type of the tree.

    Upon creation most trees have their `tpe` set to `null`. Types are typically assigned to trees during typechecking. Some node factory methods set `tpe` immediately after creation.

    When the typechecker encounters a tree with a non-null tpe, it will assume it to be correct and not check it again. This means one has to be careful not to erase the `tpe` field of subtrees.

    Definition Classes
      TreeApi

25. #### abstract def withFilter(f: (Universe.Tree) ⇒ Boolean): List[Universe.Tree]

    Find all subtrees matching predicate `p`.

    Find all subtrees matching predicate `p`. Same as `filter`

    Definition Classes
      TreeApi

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Universe.SuperApi to any2stringadd[Universe.SuperApi] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Universe.SuperApi, B)

   Implicit information
     This member is added by an implicit conversion from Universe.SuperApi to ArrowAssoc[Universe.SuperApi] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @IntrinsicCandidate() @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (Universe.SuperApi) ⇒ Boolean, msg: ⇒ Any): Universe.SuperApi

   Implicit information
     This member is added by an implicit conversion from Universe.SuperApi to Ensuring[Universe.SuperApi] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (Universe.SuperApi) ⇒ Boolean): Universe.SuperApi

   Implicit information
     This member is added by an implicit conversion from Universe.SuperApi to Ensuring[Universe.SuperApi] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): Universe.SuperApi

    Implicit information
      This member is added by an implicit conversion from Universe.SuperApi to Ensuring[Universe.SuperApi] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): Universe.SuperApi

    Implicit information
      This member is added by an implicit conversion from Universe.SuperApi to Ensuring[Universe.SuperApi] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Universe.SuperApi to StringFormat[Universe.SuperApi] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

15. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

16. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()

17. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

18. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

20. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

21. #### def productIterator: Iterator[Any]

    Definition Classes
      Product

22. #### def productPrefix: String

    Definition Classes
      Product

23. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

24. #### def toString(): String

    Obtains string representation of a tree

    Obtains string representation of a tree

    returns

      a String representation of the object.

    Definition Classes
      TreeApi → AnyRef → Any

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

28. #### def →[B](y: B): (Universe.SuperApi, B)

    Implicit information
      This member is added by an implicit conversion from Universe.SuperApi to ArrowAssoc[Universe.SuperApi] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Universe.TermTreeApi

### Inherited from Universe.TreeApi

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Universe.SuperApi to any2stringadd[Universe.SuperApi]

### Inherited by implicit conversion StringFormat from Universe.SuperApi to StringFormat[Universe.SuperApi]

### Inherited by implicit conversion Ensuring from Universe.SuperApi to Ensuring[Universe.SuperApi]

### Inherited by implicit conversion ArrowAssoc from Universe.SuperApi to ArrowAssoc[Universe.SuperApi]

### Ungrouped